package com.webssa.library.crypto;

/**
 * Created by stanislav.perchenko on 8/24/2018
 */
public interface CryptoAlgorythmParams {
    String algorythm();
    String keySpecAlgorythm();
    byte[] initVector();


    CryptoAlgorythmParams DEFAULT_AES_PARAMS = new CryptoAlgorythmParams() {

        private final byte[] aesIV  = new byte[]{(byte)0x89, (byte)0xCF, (byte)0x0A, (byte)0x1A, (byte)0xD7, (byte)0xB9, (byte)0xED, (byte)0x2C, (byte)0x6F, (byte)0xD0, (byte)0xB3, (byte)0x0A, (byte)0xC0, (byte)0xD5, (byte)0xAB, (byte)0x68};

        @Override
        public String algorythm() {
            return "AES/CBC/PKCS5Padding";
        }

        @Override
        public String keySpecAlgorythm() {
            return "AES";
        }

        @Override
        public byte[] initVector() {
            return aesIV;
        }
    };
}
