package com.webssa.library.galleryviewpager;

import android.os.Parcel;

/**
 * Created by stanislav.perchenko on 4/15/2019
 */
public class SimpleImageReference implements ImageReference {

    private final String path;

    public SimpleImageReference(String path) {
        this.path = path;
    }

    @Override
    public String getImagePath() {
        return path;
    }

    /************************  Parcelable implementation  *****************************************/
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeString(path);
    }

    private SimpleImageReference(Parcel in) {
        path = in.readString();
    }

    public static final Creator<SimpleImageReference> CREATOR = new Creator<SimpleImageReference>() {
        public SimpleImageReference createFromParcel(Parcel in) {
            return new SimpleImageReference(in);
        }

        public SimpleImageReference[] newArray(int size) {
            return new SimpleImageReference[size];
        }
    };
}
