package com.webssa.pda.sunmi.broadcasting;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Parcelable;

import androidx.annotation.Nullable;
import androidx.localbroadcastmanager.content.LocalBroadcastManager;

/**
 * Created by stanislav.perchenko on 11/18/2016.
 */

public abstract class BaseAppBroadcastReceiver extends BroadcastReceiver {


    public abstract String getActionName();
    protected abstract String getIntentMessageKey();

    public final Intent getBroadcastingIntent() {
        return new Intent(getActionName()).addFlags(Intent.FLAG_DEBUG_LOG_RESOLUTION);
    }

    public final Intent putMessageIntoIntent(Intent intent, Parcelable[] data) {
        return (data != null) ? intent.putExtra(getIntentMessageKey(), data) : intent;
    }


    public final void register(@Nullable Context context) {
        if (context != null) {
            LocalBroadcastManager.getInstance(context).registerReceiver(this, new IntentFilter(getActionName()));
        }
    }

    public final void unRegister(@Nullable Context context) {
        if (context != null) {
            LocalBroadcastManager.getInstance(context).unregisterReceiver(this);
        }
    }
}
