package com.webssa.pda.sunmi.broadcasting;

import android.content.Intent;

import androidx.localbroadcastmanager.content.LocalBroadcastManager;

import com.webssa.pda.sunmi.PDA_Application;
import com.webssa.pda.sunmi.broadcasting.impl.NoteCreatedBroadcastReceiver;
import com.webssa.pda.sunmi.broadcasting.impl.VisitStateChangedBroadcastReceiver;
import com.webssa.pda.sunmi.storage.dbmodel.impl.VisitDbModel;

/**
 * This is the helper utility class which contains all helper method to local broadcasting
 * in-app events
 *
 * Created by stanislav.perchenko on 11/6/2019, 11:25 AM.
 */
public final class BroadcastController {

    public static void broadcastNoteCreated() {
        Intent i = (new NoteCreatedBroadcastReceiver(null)).getBroadcastingIntent();
        LocalBroadcastManager.getInstance(PDA_Application.getStaticAppContext()).sendBroadcast(i);
    }

    public static void broadcastVisitStateChanged(VisitDbModel visit) {
        Intent i = (new VisitStateChangedBroadcastReceiver(null)).getFullIntent(visit);
        LocalBroadcastManager.getInstance(PDA_Application.getStaticAppContext()).sendBroadcast(i);
    }

    private BroadcastController() {
        //No instances allowed
    }
}
