package com.webssa.pda.sunmi.broadcasting;

import android.content.Context;
import android.content.Intent;

import androidx.annotation.Nullable;

import com.webssa.pda.sunmi.rest.model.IdProvidingModel;

/**
 * Created by stanislav.perchenko on 11/10/2019, 8:46 PM.
 */
public abstract class EntityChangeBroadcastReceiver<T extends IdProvidingModel> extends BaseAppBroadcastReceiver {
    private final EntityChangeCallback<T> callback;

    public EntityChangeBroadcastReceiver(@Nullable EntityChangeCallback<T> callback) {
        this.callback = callback;
    }

    @Override
    public String getActionName() {
        return getClass().getSimpleName();
    }

    @Override
    public void onReceive(Context context, Intent intent) {
        if (callback != null) callback.onEntityChanged((T) intent.getParcelableExtra(getIntentMessageKey()));
    }
}
