package com.webssa.pda.sunmi.core;

import android.os.Looper;

import androidx.lifecycle.MutableLiveData;

import com.webssa.pda.sunmi.rest.model.impl.EmergencyCategoryEntity;

import java.util.List;

/**
 * Created by stanislav.perchenko on 11/5/2019, 2:30 PM.
 */
public class EmergenciesLiveData extends MutableLiveData<List<EmergencyCategoryEntity>> {
    private final EmergencyHolder.OnEmergUpdateListener listener = new EmergencyHolder.OnEmergUpdateListener() {
        private List<EmergencyCategoryEntity> items;

        @Override
        public void onUpdated(List<EmergencyCategoryEntity> items) {
            boolean needUpd;
            synchronized (this) {
                needUpd = !items.equals(this.items);
                this.items = items;
            }

            if (needUpd && (Thread.currentThread() == Looper.getMainLooper().getThread())) {
                EmergenciesLiveData.this.setValue(items);
            } else if (needUpd) {
                EmergenciesLiveData.this.postValue(items);
            }
        }
    };


    @Override
    protected void onActive() {
        EmergencyHolder.getInstance().requestUpdates(listener);
    }

    @Override
    protected void onInactive() {
        EmergencyHolder.getInstance().removeUpdates(listener);
    }
}
