package com.webssa.pda.sunmi.dataapi;

import android.content.Context;

import com.webssa.library.core.error.AppError;
import com.webssa.pda.sunmi.rest.ApplicationRestService;
import com.webssa.pda.sunmi.rest.model.FindNewShiftResponse;

import retrofit2.Call;

/**
 * Created by stanislav.perchenko on 10/18/2019.
 */
public class ApiFindTodayNewShift extends BaseRestApi<FindNewShiftResponse, FindNewShiftResponse> {

    public static ApiFindTodayNewShift withContext(Context context) {
        return new ApiFindTodayNewShift(context);
    }

    private ApiFindTodayNewShift(Context context) {
        // Use Creator pattern
        super(context);
    }

    private long tStart;

    @Override
    protected Call<FindNewShiftResponse> getRetrofitCall() {
        tStart = System.currentTimeMillis();
        return ApplicationRestService.getInstance().findNewShiftForToday();
    }

    @Override
    protected void continueWithResponse(FindNewShiftResponse respData) {
        waitMinDuration();
        setResult(respData);
    }


    @Override
    protected void setError(AppError error) {
        waitMinDuration();
        super.setError(error);
    }

    private void waitMinDuration() {
        int dt = (int)(System.currentTimeMillis() - tStart);
        if (dt < 1300) {
            try { Thread.sleep(1300 - dt); } catch (InterruptedException e) {}
        }
    }
}
