package com.webssa.pda.sunmi.dataapi;

import android.content.Context;

import com.webssa.pda.sunmi.rest.ApplicationRestService;
import com.webssa.pda.sunmi.rest.model.impl.EWCCodeEntity;
import com.webssa.pda.sunmi.storage.dao.impl.EWCCodeDAO;

import java.util.List;

import retrofit2.Call;

public class ApiGetAllEWCCodes extends BaseRestApi<List<EWCCodeEntity>, List<EWCCodeEntity>> {

    public ApiGetAllEWCCodes(Context context) {
        super(context);
    }

    @Override
    protected Call<List<EWCCodeEntity>> getRetrofitCall() {
        return ApplicationRestService.getInstance().getAllEWCCodes();
    }

    @Override
    protected void continueWithResponse(List<EWCCodeEntity> respData) {
        try (EWCCodeDAO dao = new EWCCodeDAO()) {
            dao.beginTransaction();
            try {
                dao.removeAll();
                dao.createOrUpdateMultipleEntries(respData);
                dao.setTransactionSuccessful();
            } finally {
                dao.endTransaction();
            }
        }
        setResult(respData);
    }
}
