package com.webssa.pda.sunmi.dataapi;

import android.content.Context;

import com.webssa.pda.sunmi.rest.ApplicationRestService;
import com.webssa.pda.sunmi.rest.model.impl.PricedGoodEntity;
import com.webssa.pda.sunmi.storage.dao.impl.PricedGoodDAO;
import com.webssa.pda.sunmi.storage.dbhelper.DbSelectionCache;

import java.util.List;

import retrofit2.Call;

/**
 * Created by stanislav.perchenko on 10/18/2019.
 */
public class ApiGetAllGoodsWithPrices extends BaseRestApi<List<PricedGoodEntity>, List<PricedGoodEntity>> {



    public ApiGetAllGoodsWithPrices(Context context) {
        super(context);
    }

    @Override
    protected Call<List<PricedGoodEntity>> getRetrofitCall() {
        return ApplicationRestService.getInstance().getAllGoodsWithPrices();
    }

    protected void continueWithResponse(List<PricedGoodEntity> respData) {
        try (PricedGoodDAO dao = new PricedGoodDAO(new DbSelectionCache())) {
            dao.beginTransaction();
            try {
                dao.removeAll();
                dao.createOrUpdateMultipleEntries(respData);
                dao.setTransactionSuccessful();
            } finally {
                dao.endTransaction();
            }
        }
        setResult(respData);
    }
}
