package com.webssa.pda.sunmi.dataapi;

import android.content.Context;

import com.webssa.pda.sunmi.rest.ApplicationRestService;
import com.webssa.pda.sunmi.rest.model.impl.SiteEntity;
import com.webssa.pda.sunmi.storage.dao.impl.SitesDAO;

import java.util.List;

import retrofit2.Call;

/**
 * Created by stanislav.perchenko on 07.07.2020 at 10:43.
 */
public class ApiGetAllSites extends BaseRestApi<List<SiteEntity>, List<SiteEntity>> {

    public static ApiGetAllSites create(Context c) {
        return new ApiGetAllSites(c);
    }

    private ApiGetAllSites(Context context) {
        super(context);
    }

    @Override
    protected Call<List<SiteEntity>> getRetrofitCall() {
        return ApplicationRestService.getInstance().getAllSites();
    }

    @Override
    protected void continueWithResponse(List<SiteEntity> sites) {
        try(SitesDAO sitesDao = new SitesDAO()) {
            for (SiteEntity site : sites) {
                sitesDao.createOrUpdateInLocalDB(site);
            }
        }
        setResult(sites);
    }
}
