package com.webssa.pda.sunmi.dataapi;

import android.content.Context;

import com.webssa.library.core.error.AppError;
import com.webssa.library.core.error.BadResponseError;
import com.webssa.pda.sunmi.rest.ApplicationRestService;
import com.webssa.pda.sunmi.rest.model.LongId;
import com.webssa.pda.sunmi.rest.model.impl.ShiftRestEntity;

import retrofit2.Call;

/**
 * Created by stanislav.perchenko on 10/23/2019.
 */
public class ApiRejectShift extends BaseRestApi<ShiftRestEntity, ShiftRestEntity> {

    public static ApiRejectShift create(Context context, LongId<ShiftRestEntity> shiftId) {
        return new ApiRejectShift(context, shiftId);
    }

    private final LongId<ShiftRestEntity> shiftId;

    // Use creator pattern
    private ApiRejectShift(Context context, LongId<ShiftRestEntity> shiftId) {
        super(context);
        this.shiftId = shiftId;
    }

    @Override
    protected Call<ShiftRestEntity> getRetrofitCall() {
        return ApplicationRestService.getInstance().rejectShift(shiftId);
    }

    @Override
    protected void continueWithResponse(ShiftRestEntity resp) {

        try { //TODO Remove after testing !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            Thread.sleep(800);
        } catch (InterruptedException e) {
            System.err.println(e);
        }

        if (resp.id().equals(shiftId)) {
            setResult(resp);
        } else {
            final String msg = String.format("Wrong Shift ID was returned - %d. Expected - %d", resp.id().getValue(), shiftId.getValue());
            setError(BadResponseError.Companion.create(getContext(), msg));
        }
    }

    @Override
    protected void setError(AppError error) {
        try { //TODO Remove after testing !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
            Thread.sleep(800);
        } catch (InterruptedException e) {
            System.err.println(e);
        }
        super.setError(error);
    }
}
