package com.webssa.pda.sunmi.dataapi;

import com.webssa.library.core.processor.AbstractExecutable;
import com.webssa.pda.sunmi.rest.model.LongId;
import com.webssa.pda.sunmi.rest.model.impl.SiteEntity;
import com.webssa.pda.sunmi.storage.dao.impl.PricedGoodDAO;
import com.webssa.pda.sunmi.storage.dbhelper.DbSelectionCache;
import com.webssa.pda.sunmi.storage.dbmodel.impl.PricedGoodDbModel;

import java.util.List;

/**
 * Created by stanislav.perchenko on 11/15/2019, 11:13 AM.
 */
public class ApiSelectAllGoodsFromLocalDB extends AbstractExecutable<List<PricedGoodDbModel>> {

    private final LongId<SiteEntity> siteId;

    public ApiSelectAllGoodsFromLocalDB(LongId<SiteEntity> siteId) {
        super();
        this.siteId = siteId;
    }

    @Override
    public void executeSynchronously() throws Exception {
        try (PricedGoodDAO dao = new PricedGoodDAO(new DbSelectionCache())) {
            List<PricedGoodDbModel> items = dao.selectGoodsBySiteId(siteId);
            setResult(items);
        }
    }
}
