package com.webssa.pda.sunmi.model;

import android.os.Parcel;
import android.os.Parcelable;

import androidx.annotation.Nullable;

import com.webssa.pda.sunmi.rest.model.LongId;
import com.webssa.pda.sunmi.rest.model.impl.ShiftRestEntity;
import com.webssa.pda.sunmi.rest.model.impl.SiteEntity;
import com.webssa.pda.sunmi.util.DateNoTime;
import com.webssa.pda.sunmi.util.TimeOfDayHMS;

/**
 * Created by stanislav.perchenko on 08.07.2020 at 13:02.
 */
public class VisitCreationModel implements Parcelable {
    private final LongId<ShiftRestEntity> shiftId;
    private final LongId<SiteEntity> siteId;
    private final TimeOfDayHMS suggestTime;
    private DateNoTime shiftDate;

    public VisitCreationModel(LongId<ShiftRestEntity> shiftId, LongId<SiteEntity> siteId, @Nullable DateNoTime shiftDate, @Nullable TimeOfDayHMS suggestTime) {
        this.shiftId = shiftId;
        this.siteId = siteId;
        this.shiftDate = shiftDate;
        this.suggestTime = suggestTime;
    }

    public LongId<ShiftRestEntity> getShiftId() {
        return shiftId;
    }

    public LongId<SiteEntity> getSiteId() {
        return siteId;
    }

    public TimeOfDayHMS getSuggestTime() {
        return suggestTime;
    }

    public DateNoTime getShiftDate() {
        return shiftDate;
    }

    /*****************************  Parcelable implementation  ************************************/
    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel dest, int flags) {
        dest.writeParcelable(shiftId, flags);
        dest.writeParcelable(siteId, flags);
        dest.writeParcelable(shiftDate, flags);
        dest.writeParcelable(suggestTime, flags);
    }

    private VisitCreationModel(Parcel in) {
        shiftId = in.readParcelable(VisitCreationModel.class.getClassLoader());
        siteId = in.readParcelable(VisitCreationModel.class.getClassLoader());
        shiftDate = in.readParcelable(VisitCreationModel.class.getClassLoader());
        suggestTime = in.readParcelable(VisitCreationModel.class.getClassLoader());
    }

    public static final Creator<VisitCreationModel> CREATOR = new Creator<VisitCreationModel>() {
        public VisitCreationModel createFromParcel(Parcel in) {
            return new VisitCreationModel(in);
        }

        public VisitCreationModel[] newArray(int size) {
            return new VisitCreationModel[size];
        }
    };
}
