package com.webssa.pda.sunmi.receipt;

import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.Moshi;
import com.squareup.moshi.Types;
import com.webssa.pda.sunmi.receipt.model.ReceiptCollectedGoodModel;
import com.webssa.pda.sunmi.receipt.model.ReceiptCustomerModel;
import com.webssa.pda.sunmi.receipt.model.ReceiptDataMainModel;
import com.webssa.pda.sunmi.receipt.model.ReceiptEWCModel;
import com.webssa.pda.sunmi.receipt.model.ReceiptOrganizationModel;
import com.webssa.pda.sunmi.receipt.model.ReceiptPersonSignatureModel;
import com.webssa.pda.sunmi.receipt.model.ReceiptSiteModel;

import java.lang.annotation.Annotation;
import java.lang.reflect.Type;
import java.util.Set;

/**
 * Created by stanislav.perchenko on 11/26/2019, 7:09 PM.
 */
public class ReceiptModelsMoshiJsonFactory implements JsonAdapter.Factory {

    public static ReceiptModelsMoshiJsonFactory create() {
        return new ReceiptModelsMoshiJsonFactory();
    }

    private ReceiptModelsMoshiJsonFactory() {}

    @Override
    public JsonAdapter<?> create(Type type, Set<? extends Annotation> annotations, Moshi moshi) {
        if (!annotations.isEmpty()) return null;
        Class<?> rawType = Types.getRawType(type);
        if (ReceiptCollectedGoodModel.class.isAssignableFrom(rawType)) {
            return ReceiptCollectedGoodModel.jsonAdapter(moshi);

        } else if (ReceiptCustomerModel.class.isAssignableFrom(rawType)) {
            return ReceiptCustomerModel.jsonAdapter(moshi);

        } else if (ReceiptDataMainModel.class.isAssignableFrom(rawType)) {
            return ReceiptDataMainModel.jsonAdapter(moshi);

        } else if (ReceiptEWCModel.class.isAssignableFrom(rawType)) {
            return ReceiptEWCModel.jsonAdapter(moshi);

        } else if (ReceiptOrganizationModel.class.isAssignableFrom(rawType)) {
            return ReceiptOrganizationModel.jsonAdapter(moshi);

        } else if (ReceiptPersonSignatureModel.class.isAssignableFrom(rawType)) {
            return ReceiptPersonSignatureModel.jsonAdapter(moshi);

        } else if (ReceiptSiteModel.class.isAssignableFrom(rawType)) {
            return ReceiptSiteModel.jsonAdapter(moshi);

        }
        return null;
    }
}
