package com.webssa.pda.sunmi.receipt.model;

import android.os.Parcelable;

import com.google.auto.value.AutoValue;
import com.squareup.moshi.Json;
import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.Moshi;

/**
 * Created by stanislav.perchenko on 11/26/2019, 1:21 PM.
 */
@AutoValue
public abstract class ReceiptCollectedGoodModel implements Parcelable {

    @Json(name = "full_category_name")
    public abstract String goodName();

    @Json(name = "ewc_code")
    public abstract String ewcCode();

    @Json(name = "weight_kg")
    public abstract Integer collectedAmount();

    @Json(name = "amount")
    public abstract Integer payedAmount();

    @Json(name = "currency_scale")
    public abstract Integer payedScale();

    public static JsonAdapter<ReceiptCollectedGoodModel> jsonAdapter(Moshi moshi) {
        return new AutoValue_ReceiptCollectedGoodModel.MoshiJsonAdapter(moshi);
    }

    public static Builder builder() {
        return new AutoValue_ReceiptCollectedGoodModel.Builder();
    }


    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setGoodName(String goodName);
        public abstract Builder setEwcCode(String ewcCode);
        public abstract Builder setCollectedAmount(Integer collectedAmount);
        public abstract Builder setPayedAmount(Integer payedAmount);
        public abstract Builder setPayedScale(Integer payedScale);

        public abstract ReceiptCollectedGoodModel build();
    }

}
