package com.webssa.pda.sunmi.receipt.model;

import android.os.Parcelable;

import com.google.auto.value.AutoValue;
import com.squareup.moshi.Json;
import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.Moshi;

/**
 * Created by stanislav.perchenko on 11/26/2019, 1:17 PM.
 */
@AutoValue
public abstract class ReceiptCustomerModel implements Parcelable {

    @Json(name = "name")
    public abstract String customerName();

    @Json(name = "signature")
    public abstract ReceiptPersonSignatureModel customerSignature();

    public static JsonAdapter<ReceiptCustomerModel> jsonAdapter(Moshi moshi) {
        return new AutoValue_ReceiptCustomerModel.MoshiJsonAdapter(moshi);
    }

    public static Builder builder() {
        return new AutoValue_ReceiptCustomerModel.Builder();
    }


    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setCustomerName(String customerName);
        public abstract Builder setCustomerSignature(ReceiptPersonSignatureModel customerSignature);

        public abstract ReceiptCustomerModel build();
    }

}
