package com.webssa.pda.sunmi.receipt.model;

import android.os.Parcelable;

import com.google.auto.value.AutoValue;
import com.squareup.moshi.Json;
import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.JsonClass;
import com.squareup.moshi.Moshi;

import java.util.List;

/**
 * Created by stanislav.perchenko on 11/26/2019, 1:10 PM.
 */
@AutoValue
public abstract class ReceiptDataMainModel implements Parcelable {

    @Json(name = "organization")
    public abstract ReceiptOrganizationModel organization();

    @Json(name = "shop")
    public abstract ReceiptSiteModel site();

    @Json(name = "receipt_number")
    public abstract String receiptNumber();

    @Json(name = "now_timestamp")
    public abstract Long receiptTimestamp();

    @Json(name = "payment_method")
    public abstract String paymentMethod();

    @Json(name = "driver_name")
    public abstract String driverName();

    @Json(name = "customer")
    public abstract ReceiptCustomerModel customer();

    @Json(name = "ewc_codes")
    public abstract List<ReceiptEWCModel> ewcCodes();

    @Json(name = "collected_goods")
    public abstract List<ReceiptCollectedGoodModel> collectedGoods();

    public static JsonAdapter<ReceiptDataMainModel> jsonAdapter(Moshi moshi) {
        return new AutoValue_ReceiptDataMainModel.MoshiJsonAdapter(moshi);
    }

    public static Builder builder() {
        return new AutoValue_ReceiptDataMainModel.Builder();
    }

    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setOrganization(ReceiptOrganizationModel organization);
        public abstract Builder setSite(ReceiptSiteModel site);
        public abstract Builder setReceiptNumber(String receiptNumber);
        public abstract Builder setReceiptTimestamp(Long receiptTimestamp);
        public abstract Builder setPaymentMethod(String paymentMethod);
        public abstract Builder setDriverName(String driverName);
        public abstract Builder setCustomer(ReceiptCustomerModel customer);
        public abstract Builder setEwcCodes(List<ReceiptEWCModel> ewcCodes);
        public abstract Builder setCollectedGoods(List<ReceiptCollectedGoodModel> collectedGoods);

        public abstract ReceiptDataMainModel build();
    }

}
