package com.webssa.pda.sunmi.receipt.model;

import android.os.Parcelable;

import com.google.auto.value.AutoValue;
import com.squareup.moshi.Json;
import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.Moshi;

/**
 * Created by stanislav.perchenko on 11/26/2019, 1:19 PM.
 */
@AutoValue
public abstract class ReceiptEWCModel implements Parcelable {

    @Json(name = "title")
    public abstract String ewcTitle();

    @Json(name = "code")
    public abstract String ewcCode();

    public static JsonAdapter<ReceiptEWCModel> jsonAdapter(Moshi moshi) {
        return new AutoValue_ReceiptEWCModel.MoshiJsonAdapter(moshi);
    }

    public static Builder builder() {
        return new AutoValue_ReceiptEWCModel.Builder();
    }

    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setEwcTitle(String ewcTitle);
        public abstract Builder setEwcCode(String ewcCode);

        public abstract ReceiptEWCModel build();
    }

}
