package com.webssa.pda.sunmi.receipt.model;

import android.os.Parcelable;

import com.google.auto.value.AutoValue;
import com.squareup.moshi.Json;
import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.Moshi;

import java.util.List;

/**
 * Created by stanislav.perchenko on 11/26/2019, 1:12 PM.
 */
@AutoValue
public abstract class ReceiptOrganizationModel implements Parcelable {

    @Json(name = "title")
    public abstract String organizationTitle();

    @Json(name = "address")
    public abstract List<String> addressLines();

    @Json(name = "telephone")
    public abstract String phone();

    @Json(name = "fax")
    public abstract String fax();

    @Json(name = "email")
    public abstract String email();

    @Json(name = "web")
    public abstract String website();

    @Json(name = "waste_carrier_license")
    public abstract String wasteCarrierLicense();

    @Json(name = "vat_reg_number")
    public abstract String vatRegNumber();

    public static JsonAdapter<ReceiptOrganizationModel> jsonAdapter(Moshi moshi) {
        return new AutoValue_ReceiptOrganizationModel.MoshiJsonAdapter(moshi);
    }

    public static Builder builder() {
        return new AutoValue_ReceiptOrganizationModel.Builder();
    }

    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setOrganizationTitle(String organizationTitle);
        public abstract Builder setAddressLines(List<String> addressLines);
        public abstract Builder setPhone(String phone);
        public abstract Builder setFax(String fax);
        public abstract Builder setEmail(String email);
        public abstract Builder setWebsite(String website);
        public abstract Builder setWasteCarrierLicense(String wasteCarrierLicense);
        public abstract Builder setVatRegNumber(String vatRegNumber);

        public abstract ReceiptOrganizationModel build();
    }

}
