package com.webssa.pda.sunmi.receipt.model;

import android.os.Parcelable;

import com.google.auto.value.AutoValue;
import com.squareup.moshi.Json;
import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.Moshi;

/**
 * Created by stanislav.perchenko on 11/26/2019, 1:36 PM.
 */
@AutoValue
public abstract class ReceiptPersonSignatureModel implements Parcelable {

    @Json(name = "width")
    public abstract Integer w();

    @Json(name = "height")
    public abstract Integer h();

    @Json(name = "data")
    public abstract String signData();

    public static JsonAdapter<ReceiptPersonSignatureModel> jsonAdapter(Moshi moshi) {
        return new AutoValue_ReceiptPersonSignatureModel.MoshiJsonAdapter(moshi);
    }

    public static Builder builder() {
        return new AutoValue_ReceiptPersonSignatureModel.Builder();
    }

    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setW(Integer w);
        public abstract Builder setH(Integer h);
        public abstract Builder setSignData(String signData);

        public abstract ReceiptPersonSignatureModel build();
    }

}
