package com.webssa.pda.sunmi.receipt.model;

import android.os.Parcelable;

import com.google.auto.value.AutoValue;
import com.squareup.moshi.Json;
import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.Moshi;

/**
 * Created by stanislav.perchenko on 11/26/2019, 1:14 PM.
 */
@AutoValue
public abstract class ReceiptSiteModel implements Parcelable {

    @Json(name = "name")
    public abstract String name();

    @Json(name = "code")
    public abstract String code();

    public static JsonAdapter<ReceiptSiteModel> jsonAdapter(Moshi moshi) {
        return new AutoValue_ReceiptSiteModel.MoshiJsonAdapter(moshi);
    }

    public static Builder builder() {
        return new AutoValue_ReceiptSiteModel.Builder();
    }

    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setName(String name);
        public abstract Builder setCode(String code);

        public abstract ReceiptSiteModel build();
    }

}
