package com.webssa.pda.sunmi.rest.helper

import java.util.Date

/**
 * This class is to be used with Retrofit, when a Date should be passed as query parameter
 * It encapsulated Date instance and overrides toString() to represent
 * date in API format
 */
final class DateQueryParameter(private val date: Date) {

    fun getDate(): Date {
        return Date(date.time)
    }

    override fun toString(): String {
        return HttpClientUtils.dateToServerTime(date)
    }
}
