package com.webssa.pda.sunmi.rest.helper;

import com.squareup.moshi.Moshi;
import com.squareup.moshi.Types;
import com.squareup.moshi.kotlin.reflect.KotlinJsonAdapterFactory;
import com.webssa.pda.sunmi.model.VisitCreationModel;
import com.webssa.pda.sunmi.rest.jsonadapter.DateJsonAdapter;
import com.webssa.pda.sunmi.rest.jsonadapter.DateNoTimeJsonAdapter;
import com.webssa.pda.sunmi.rest.jsonadapter.DriverLoginRequestJsonAdapter;
import com.webssa.pda.sunmi.rest.jsonadapter.DurationHMSJsonAdapter;
import com.webssa.pda.sunmi.rest.jsonadapter.LocationJsonAdapter;
import com.webssa.pda.sunmi.rest.jsonadapter.LongIdJsonAdapter;
import com.webssa.pda.sunmi.rest.jsonadapter.TimeOfDayHMSJsonAdapter;
import com.webssa.pda.sunmi.rest.jsonadapter.UriJsonAdapter;
import com.webssa.pda.sunmi.rest.jsonadapter.VisitCreationModelJsonAdapter;
import com.webssa.pda.sunmi.rest.jsonadapter.VisitResultPostBodyJsonAdapter;
import com.webssa.pda.sunmi.rest.model.DriverLoginRequest;
import com.webssa.pda.sunmi.rest.model.LongId;
import com.webssa.pda.sunmi.rest.model.impl.CollectedGoodEntity;
import com.webssa.pda.sunmi.rest.model.impl.EWCCodeEntity;
import com.webssa.pda.sunmi.rest.model.impl.EmergencyCategoryEntity;
import com.webssa.pda.sunmi.rest.model.impl.NoteEntity;
import com.webssa.pda.sunmi.rest.model.impl.PriceEntity;
import com.webssa.pda.sunmi.rest.model.impl.PricedGoodEntity;
import com.webssa.pda.sunmi.rest.model.impl.ShiftRestEntity;
import com.webssa.pda.sunmi.rest.model.impl.SiteEntity;
import com.webssa.pda.sunmi.rest.model.impl.VisitEntity;

public final class ParserProvider {

    public static Moshi getApplicationMoshi() {
        Moshi m = new Moshi.Builder()

                .add(DriverLoginRequest.class, new DriverLoginRequestJsonAdapter())
                .add(Types.newParameterizedType(LongId.class, SiteEntity.class), new LongIdJsonAdapter<SiteEntity>())
                .add(Types.newParameterizedType(LongId.class, NoteEntity.class), new LongIdJsonAdapter<NoteEntity>())
                .add(Types.newParameterizedType(LongId.class, PriceEntity.class), new LongIdJsonAdapter<PriceEntity>())
                .add(Types.newParameterizedType(LongId.class, VisitEntity.class), new LongIdJsonAdapter<VisitEntity>())
                .add(Types.newParameterizedType(LongId.class, EWCCodeEntity.class), new LongIdJsonAdapter<EWCCodeEntity>())
                .add(Types.newParameterizedType(LongId.class, ShiftRestEntity.class), new LongIdJsonAdapter<ShiftRestEntity>())
                .add(Types.newParameterizedType(LongId.class, PricedGoodEntity.class), new LongIdJsonAdapter<PricedGoodEntity>())
                .add(Types.newParameterizedType(LongId.class, CollectedGoodEntity.class), new LongIdJsonAdapter<CollectedGoodEntity>())
                .add(Types.newParameterizedType(LongId.class, EmergencyCategoryEntity.class), new LongIdJsonAdapter<EmergencyCategoryEntity>())
                .add(VisitCreationModel.class, new VisitCreationModelJsonAdapter())
                .add(DateJsonAdapter.FACTORY)
                .add(UriJsonAdapter.FACTORY)
                .add(DateNoTimeJsonAdapter.FACTORY)
                .add(TimeOfDayHMSJsonAdapter.FACTORY)
                .add(DurationHMSJsonAdapter.FACTORY)
                .add(LocationJsonAdapter.FACTORY)
                .add(VisitResultPostBodyJsonAdapter.Companion.getFACTORY())
                .build();

        return m.newBuilder()
                .add(new KotlinJsonAdapterFactory())
                .build();
    }

    private ParserProvider() { }
}
