package com.webssa.pda.sunmi.rest.jsonadapter;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.JsonReader;
import com.squareup.moshi.JsonWriter;
import com.webssa.pda.sunmi.util.DateNoTime;

import java.io.IOException;
import java.text.ParseException;

public class DateNoTimeJsonAdapter extends JsonAdapter<DateNoTime> {

    public static final JsonAdapter.Factory FACTORY = (type, ___, __) -> (type == DateNoTime.class) ? new DateNoTimeJsonAdapter() : null;

    // Use factory only for creation!
    private DateNoTimeJsonAdapter() { }

    @Nullable
    @Override
    public DateNoTime fromJson(JsonReader reader) throws IOException {
        try {
            Object value = reader.readJsonValue();
            return (value instanceof String) ? DateNoTime.parseDateNoTime((String) value) : null;
        } catch (ParseException e) {
            System.err.println(e.getMessage());
            throw new IOException("DateNoTimeJsonAdapter@fromJson - parse error: "+e.getMessage(), e);
        }
    }

    @Override
    public void toJson(JsonWriter writer, @Nullable DateNoTime value) throws IOException {
        writer.value(value == null ? null : value.toString());
    }

    @NonNull
    @Override
    public String toString() {
        return "JsonAdapter<DateNoTime>";
    }
}
