package com.webssa.pda.sunmi.rest.jsonadapter

import com.squareup.moshi.JsonAdapter
import com.squareup.moshi.JsonReader
import com.squareup.moshi.JsonWriter
import com.webssa.library.security.HashCalculator
import com.webssa.pda.sunmi.rest.model.DriverLoginRequest
import com.webssa.pda.sunmi.rest.model.LoginMode

class DriverLoginRequestJsonAdapter : JsonAdapter<DriverLoginRequest>() {


    override fun toString(): String = "GeneratedJsonAdapter(DriverLoginRequest)"

    override fun fromJson(reader: JsonReader): DriverLoginRequest {
        throw IllegalStateException("Not implemented")
    }

    override fun toJson(writer: JsonWriter, value: DriverLoginRequest?) {
        if (value == null) {
            throw NullPointerException("value was null! Wrap in .nullSafe() to write nullable values.")
        }
        writer.beginObject()
        writer.name("imei")
        writer.value(value.imei)
        if (value.loginType == LoginMode.BY_EMAIL) {
            writer.name("email")
        } else if (value.loginType == LoginMode.BY_PHONE_NUMBER) {
            writer.name("phone")
        }
        writer.value(value.login)
        writer.name("pwd")
        val hash: String = HashCalculator.createForSHA256().process(value.password).base64Hash
        writer.value(hash)
        writer.endObject()
    }
}