package com.webssa.pda.sunmi.rest.jsonadapter;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.JsonReader;
import com.squareup.moshi.JsonWriter;
import com.webssa.pda.sunmi.util.DurationHMS;

import java.io.IOException;
import java.text.ParseException;

public class DurationHMSJsonAdapter extends JsonAdapter<DurationHMS> {

    public static final JsonAdapter.Factory FACTORY = (type, ___, __) -> (type == DurationHMS.class) ? new DurationHMSJsonAdapter() : null;

    // Use factory only for creation!
    private DurationHMSJsonAdapter() { }

    @Nullable
    @Override
    public DurationHMS fromJson(JsonReader reader) throws IOException {
        try {
            Object value = reader.readJsonValue();
            return (value instanceof String) ? DurationHMS.parseDurationHMS((String) value) : null;
        } catch (ParseException e) {
            System.err.println(e.getMessage());
            throw new IOException("DurationHMSJsonAdapter@fromJson - parse error: "+e.getMessage(), e);
        }
    }

    @Override
    public void toJson(JsonWriter writer, @Nullable DurationHMS value) throws IOException {
        writer.value(value == null ? null : value.toString());
    }

    @NonNull
    @Override
    public String toString() {
        return "JsonAdapter<DurationHMS>";
    }
}
