package com.webssa.pda.sunmi.rest.jsonadapter;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.JsonReader;
import com.squareup.moshi.JsonWriter;
import com.webssa.pda.sunmi.rest.model.IdProvidingModel;
import com.webssa.pda.sunmi.rest.model.LongId;

import java.io.IOException;

public class LongIdJsonAdapter<T extends IdProvidingModel> extends JsonAdapter<LongId<T>> {

    //public static final JsonAdapter.Factory FACTORY = (type, ___, __) -> (type == Types.newParameterizedType(LongId.class, ShiftRestEntity.class)) ? new LongIdJsonAdapter<ShiftRestEntity>() : null;

    @Nullable
    @Override
    public LongId<T> fromJson(JsonReader reader) throws IOException {
        Object value = reader.readJsonValue();
        return (value instanceof Number) ? LongId.Companion.valueOf(((Number) value).longValue()) : null;
    }

    @Override
    public void toJson(JsonWriter writer, @Nullable LongId<T> value) throws IOException {
        writer.value(value == null ? null : value.getValue());
    }

    @NonNull
    @Override
    public String toString() {
        return "LongIdJsonAdapter<T extends IdProvidingModel>";
    }
}
