package com.webssa.pda.sunmi.rest.jsonadapter;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.squareup.moshi.JsonAdapter;
import com.squareup.moshi.JsonReader;
import com.squareup.moshi.JsonWriter;
import com.webssa.pda.sunmi.util.TimeOfDayHMS;

import java.io.IOException;
import java.text.ParseException;

public class TimeOfDayHMSJsonAdapter extends JsonAdapter<TimeOfDayHMS> {

    public static final JsonAdapter.Factory FACTORY = (type, ___, __) -> (type == TimeOfDayHMS.class) ? new TimeOfDayHMSJsonAdapter() : null;

    // Use factory only for creation!
    private TimeOfDayHMSJsonAdapter() { }

    @Nullable
    @Override
    public TimeOfDayHMS fromJson(JsonReader reader) throws IOException {
        try {
            Object value = reader.readJsonValue();
            return (value instanceof String) ? TimeOfDayHMS.parseTime((String) value) : null;
        } catch (ParseException e) {
            System.err.println(e.getMessage());
            throw new IOException("TimeOfDayHMSJsonAdapter@fromJson - parse error: "+e.getMessage(), e);
        }
    }

    @Override
    public void toJson(JsonWriter writer, @Nullable TimeOfDayHMS value) throws IOException {
        writer.value(value == null ? null : value.toString());
    }

    @NonNull
    @Override
    public String toString() {
        return "JsonAdapter<TimeOfDay>";
    }
}
