package com.webssa.pda.sunmi.rest.jsonadapter

import com.squareup.moshi.JsonAdapter
import com.squareup.moshi.JsonReader
import com.squareup.moshi.JsonWriter
import com.webssa.pda.sunmi.model.VisitCreationModel

/**
 * Created by stanislav.perchenko on 08.07.2020 at 14:35.
 */
class VisitCreationModelJsonAdapter : JsonAdapter<VisitCreationModel>() {

    override fun toString(): String = "VisitCreationModelJsonAdapter(VisitCreationModel)"


    override fun fromJson(reader: JsonReader): VisitCreationModel {
        throw IllegalStateException("Not implemented")
    }

    override fun toJson(writer: JsonWriter, value: VisitCreationModel?) {
        if (value == null) {
            throw NullPointerException("value was null! Wrap in .nullSafe() to write nullable values.")
        }
        writer.beginObject();
        writer.name("shift_id")
        writer.value(value.shiftId.value)
        writer.name("site_id")
        writer.value(value.siteId.value)
        if ((value.shiftDate != null) && (value.suggestTime != null)) {
            writer.name("suggest_time")
            writer.value(String.format("%sT%s.000Z", value.shiftDate.toString(), value.suggestTime.toString()))
        }
        writer.endObject()
    }


}