package com.webssa.pda.sunmi.rest.model

import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import com.webssa.pda.sunmi.rest.model.impl.PriceEntity
import com.webssa.pda.sunmi.rest.model.impl.PricedGoodEntity
import com.webssa.pda.sunmi.rest.model.impl.VisitEntity

@JsonClass(generateAdapter = true)
data class CollectedGoodUploadEntity (
        @Json(name = "visit_id")
        val visitId: LongId<VisitEntity>,

        @Json(name = "goodcategory_id")
        val goodcategoryId: LongId<PricedGoodEntity>,

        @Json(name = "price_id")
        val priceId: LongId<PriceEntity>,

        @Json(name = "weight")
        val collectedWeight: Int


) : IdProvidingModel {
    @Transient
    private lateinit var cachedId: LongId<CollectedGoodUploadEntity>


    override fun id(): LongId<CollectedGoodUploadEntity> {
        if (! ::cachedId.isInitialized) {
            synchronized(this) {
                if (! ::cachedId.isInitialized) {
                    var value: Long = ((visitId.value shl 16) and Long.MAX_VALUE) or (goodcategoryId.value and 0xFFFF)
                    cachedId = LongId.valueOf(value)
                }
            }
        }
        return cachedId
    }
}