package com.webssa.pda.sunmi.rest.model

import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class LoginAnswer(
        @Json(name = "success")
        val isSuccess: Boolean = false,

        @Json(name = "msg_error")
        val errorMessage: String? = null,

        @Json(name = "access_token")
        val accessToken: String? = null,

        @Json(name = "expiresIn_wrong")
        val expiresIn: Int? = Integer.MAX_VALUE,

        @Json(name = "refresh_token")
        val refreshToken: String? = null,

        @Json(name = "user")
        val user: UserEntity? = null,

        @Json(name = "shift_start")
        val shiftStart: String? = null,

        @Json(name = "shift_end")
        val shiftEnd: String? = null,

        @Json(name = "diesel_purchase")
        val dieselPurchase: String? = null
) {

    fun validate() {
        if (isSuccess) {
            when {
                errorMessage != null -> throw IllegalStateException("Success is true but 'errorMessage' is not null")
                accessToken == null -> throw IllegalStateException("Success is true but 'accessToken' is null")
                refreshToken == null -> throw IllegalStateException("Success is true but 'refreshToken' is null")
                user == null -> throw IllegalStateException("Success is true but 'user' is null")
            }
        } else {
            when {
                errorMessage == null -> throw IllegalStateException("Success is false but 'errorMessage' is null")
                accessToken != null -> throw IllegalStateException("Success is false but 'accessToken' is not null")
                refreshToken != null -> throw IllegalStateException("Success is false but 'refreshToken' is not null")
                user != null -> throw IllegalStateException("Success is false but 'user' is not null")
            }
        }
    }
}