package com.webssa.pda.sunmi.rest.model

import android.net.Uri
import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import com.webssa.pda.sunmi.util.DateNoTime

@JsonClass(generateAdapter = true)
data class UserEntity (
        @Json(name = "user_id")
        val userId: String,

        @Json(name = "registration_date")
        val registrationDate: DateNoTime,

        @Json(name = "first_name")
        val firstName: String? = "",

        @Json(name = "surname")
        val familyName: String? = "",

        @Json(name = "photo_url")
        val photoUrl: Uri? = null,

        @Json(name = "phone_number")
        val phoneNumber: String,

        @Json(name = "email")
        val email: String,

        @Json(name = "role")
        val role: UserRole

) {
        val fullName = "$firstName $familyName"
}