package com.webssa.pda.sunmi.rest.model

import android.net.Uri
import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import com.webssa.pda.sunmi.rest.model.impl.VisitEntity
import java.util.*

@JsonClass(generateAdapter = false) // There is manually-written adapter - com.webssa.pda.sunmi.rest.jsonadapter.VisitResultPostBodyJsonAdapter
data class VisitResultPostBody(
        @Json(name = "visit_id")
        val visitId: LongId<VisitEntity>,

        @Json(name = "delayed_complete_time")
        val delayedCompleteTime: Date? = null,

        @Json(name = "customer_name")
        val customerName: String,

        @Json(name = "customer_signature")
        val customerSign: String,

        @Json(name = "note_opt_emergency_id")
        val optEmergencyId: Long? = null,

        @Json(name = "note_text")
        val optNoteText: String? = null,

        @Json(name = "note_images")
        val noteImages: List<Uri>? = Collections.unmodifiableList(Collections.emptyList()),

        @Json(name = "goods")
        val collectedGoods: List<CollectedGoodUploadEntity>? = Collections.unmodifiableList(Collections.emptyList()),

        @Json(name = "white_sacks")
        val whiteSacks: Boolean,

        @Json(name = "clear_bags")
        val clearBags: Int
)