package com.webssa.pda.sunmi.rest.model.impl

import android.os.Parcel
import android.os.Parcelable
import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import com.webssa.pda.sunmi.rest.model.IdProvidingModel
import com.webssa.pda.sunmi.rest.model.LongId

@JsonClass(generateAdapter = true)
data class CollectedGoodEntity(
        @Json(name = "id")
        val id: LongId<CollectedGoodEntity>,

        @Json(name = "visit_id")
        val visitId: LongId<VisitEntity>,

        @Json(name = "goodcategory_id")
        val goodcategoryId: LongId<PricedGoodEntity>? = null,

        @Json(name = "name")
        val goodName: String,

        @Json(name = "weight")
        val collectedWeight: Int,

        @Json(name = "total_amount")
        val collectedTotalAmount: Int,

        @Json(name = "total_scale")
        val collectedTotalScale: Int,

        @Json(name = "order")
        val order: Int
) : IdProvidingModel, Parcelable {

        override fun id(): LongId<CollectedGoodEntity> {
                return id
        }

        override fun describeContents() = 0

        private constructor(p: Parcel) : this(
                id = p.readParcelable(LongId.javaClass.classLoader),
                visitId =  p.readParcelable(LongId.javaClass.classLoader),
                goodcategoryId = p.readParcelable(LongId.javaClass.classLoader),
                goodName = p.readString(),
                collectedWeight = p.readInt(),
                collectedTotalAmount = p.readInt(),
                collectedTotalScale = p.readInt(),
                order = p.readInt()
        )

        override fun writeToParcel(p: Parcel, flags: Int) {
                p.writeParcelable(id, flags)
                p.writeParcelable(visitId, flags)
                p.writeParcelable(goodcategoryId, flags)
                p.writeString(goodName)
                p.writeInt(collectedWeight)
                p.writeInt(collectedTotalAmount)
                p.writeInt(collectedTotalScale)
                p.writeInt(order)
        }

        companion object {
                @JvmField
                val CREATOR = object : Parcelable.Creator<CollectedGoodEntity> {
                        override fun createFromParcel(parcel: Parcel) = CollectedGoodEntity(parcel)
                        override fun newArray(size: Int) = arrayOfNulls<CollectedGoodEntity>(size)
                }
        }
}