package com.webssa.pda.sunmi.rest.model.impl

import android.os.Parcel
import android.os.Parcelable
import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import com.webssa.pda.sunmi.rest.model.IdProvidingModel
import com.webssa.pda.sunmi.rest.model.LongId

@JsonClass(generateAdapter = true)
data class EmergencyCategoryEntity(
        @Json(name = "emergency_id")
        val id: LongId<EmergencyCategoryEntity>,

        @Json(name = "title")
        val title: String,

        @Json(name = "order")
        val order: Int = 0

) : IdProvidingModel, CharSequence, Parcelable {

    override fun id(): LongId<EmergencyCategoryEntity> {
        return id
    }


    override val length: Int
        get() = title.length

    override fun get(index: Int): Char {
        return title[index]
    }

    override fun subSequence(start: Int, end: Int): CharSequence {
        return title.subSequence(start, end)
    }

    override fun toString(): String {
        return title
    }

    /**********************************************************************************************/

    override fun describeContents() = 0

    private constructor(p: Parcel) : this(
            id = p.readParcelable(LongId.javaClass.classLoader),
            title = p.readString(),
            order = p.readInt()
    )

    override fun writeToParcel(dest: Parcel, flags: Int) {
        dest.writeParcelable(id, flags)
        dest.writeString(title)
        dest.writeInt(order)
    }

    companion object {
        @JvmField
        val CREATOR = object : Parcelable.Creator<EmergencyCategoryEntity> {
            override fun createFromParcel(parcel: Parcel) = EmergencyCategoryEntity(parcel)
            override fun newArray(size: Int) = arrayOfNulls<EmergencyCategoryEntity>(size)
        }
    }

}