package com.webssa.pda.sunmi.rest.model.impl

import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import com.webssa.pda.sunmi.rest.model.IdProvidingModel
import com.webssa.pda.sunmi.rest.model.LongId
import java.util.*

@JsonClass(generateAdapter = true)
data class NoteEntity(
        @Json(name = "note_id")
        val noteId: LongId<NoteEntity>,

        @Json(name = "shift_id")
        val shiftId: LongId<ShiftRestEntity>,

        @Json(name = "visit_id")
        val visitId: LongId<VisitEntity>? = null,

        @Json(name = "number")
        val sequenceNumber: Int,

        @Json(name = "author_id")
        val authorId: String,

        @Json(name = "time_created")
        val timeCreated: Date,

        @Json(name = "text")
        val text: String,

        @Json(name = "images")
        val imagesUrlSet: Set<String>,

        @Json(name = "opt_emergency_id")
        val optEmergencyId: LongId<EmergencyCategoryEntity>? = null

) : IdProvidingModel {

    override fun id(): LongId<NoteEntity> {
        return noteId
    }

}