package com.webssa.pda.sunmi.rest.model.impl

import android.os.Parcel
import android.os.Parcelable
import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import com.webssa.library.util.StringJoinerCompat
import com.webssa.pda.sunmi.rest.model.IdProvidingModel
import com.webssa.pda.sunmi.rest.model.LongId
import java.util.*

@JsonClass(generateAdapter = true)
data class PricedGoodEntity(
        @Json(name = "goodcategory_id")
        val id: LongId<PricedGoodEntity>,

        @Json(name = "name")
        val categoryName: String,

        @Json(name = "order")
        val categoryOrder: Int = 0,

        @Json(name = "price_id")
        val priceId: LongId<PriceEntity>,

        @Json(name = "price_value")
        val priceValue: Int,

        @Json(name = "price_scale")
        val priceScale: Int,

        @Json(name = "price_time_set")
        val priceSetDate: Date,

        @Json(name = "ewc_code_id")
        val ewcCodeId: LongId<EWCCodeEntity>,

        @Json(name = "unit_of_measure")
        val unitOfMeasure: String? = null,

        @Json(name = "site_id")
        val siteId: LongId<SiteEntity>

) : IdProvidingModel, Parcelable {

    override fun id(): LongId<PricedGoodEntity> {
        return id
    }

    override fun describeContents() = 0

    private constructor(p: Parcel) : this(
            id = p.readParcelable(PricedGoodEntity.javaClass.classLoader),
            categoryName = p.readString(),
            categoryOrder = p.readInt(),
            priceId = p.readParcelable(PricedGoodEntity.javaClass.classLoader),
            priceValue = p.readInt(),
            priceScale = p.readInt(),
            priceSetDate = Date(p.readLong()),
            ewcCodeId = p.readParcelable(PricedGoodEntity.javaClass.classLoader),
            unitOfMeasure = p.readString(),
            siteId = p.readParcelable(PricedGoodEntity.javaClass.classLoader)
    )

    override fun writeToParcel(p: Parcel, flags: Int) {
        p.writeParcelable(id, flags)
        p.writeString(categoryName)
        p.writeInt(categoryOrder)
        p.writeParcelable(priceId, flags)
        p.writeInt(priceValue)
        p.writeInt(priceScale)
        p.writeLong(priceSetDate.time)
        p.writeParcelable(ewcCodeId, flags)
        p.writeString(unitOfMeasure)
        p.writeParcelable(siteId, flags)
    }

    companion object {
        @JvmField
        val CREATOR = object : Parcelable.Creator<PricedGoodEntity> {
            override fun createFromParcel(parcel: Parcel) = PricedGoodEntity(parcel)
            override fun newArray(size: Int) = arrayOfNulls<PricedGoodEntity>(size)
        }
    }


    class Builder {
        private lateinit var id: LongId<PricedGoodEntity>
        private lateinit var categoryName: String
        private var categoryOrder: Int = 0
        private lateinit var priceId: LongId<PriceEntity>
        private lateinit var priceValue: Number
        private lateinit var priceScale: Number
        private lateinit var priceDate: Date
        private lateinit var ewcId: LongId<EWCCodeEntity>
        private var measureUnit: String? = null
        private lateinit var siteId: LongId<SiteEntity>

        fun setId(id: LongId<PricedGoodEntity>) = apply { this.id = id }
        fun setCategoryName(categoryName: String) = apply { this.categoryName = categoryName }
        fun setCategoryOrder(categoryOrder: Int) = apply { this.categoryOrder = categoryOrder }
        fun setPriceId(priceId: LongId<PriceEntity>) = apply { this.priceId = priceId }
        fun setPriceValue(priceValue: Int) = apply { this.priceValue = priceValue }
        fun setPriceScale(priceScale: Int) = apply { this.priceScale = priceScale }
        fun setPriceDate(d: Date) = apply { this.priceDate = d }
        fun setEwcId(ewcId: LongId<EWCCodeEntity>) = apply { this.ewcId = ewcId }
        fun setMeasureUnit(unit: String) = apply { this.measureUnit = unit }
        fun setSiteId(siteId: LongId<SiteEntity>) = apply { this.siteId = siteId }

        fun build(): PricedGoodEntity {
            val missed = StringJoinerCompat(", ", "", "")

            if (!::id.isInitialized) missed.add("id")
            if (!::categoryName.isInitialized) missed.add("categoryName")
            if (!::priceId.isInitialized) missed.add("priceId")
            if (!::priceValue.isInitialized) missed.add("priceValue")
            if (!::priceScale.isInitialized) missed.add("priceScale")
            if (!::priceDate.isInitialized) missed.add("priceDate")
            if (!::ewcId.isInitialized) missed.add("ewcId")

            if (missed.length() == 0) {
                return PricedGoodEntity(id = id,
                        categoryName = categoryName,
                        categoryOrder = categoryOrder,
                        priceId = priceId,
                        priceValue = priceValue.toInt(),
                        priceScale = priceScale.toInt(),
                        priceSetDate = priceDate,
                        ewcCodeId = ewcId,
                        unitOfMeasure = measureUnit,
                        siteId = siteId)
            } else {
                throw IllegalStateException("PricedGoodEntity.Builder - some fields are missed: $missed")
            }
        }
    }
}