package com.webssa.pda.sunmi.rest.model.impl

import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import com.webssa.pda.sunmi.rest.model.IdProvidingModel
import com.webssa.pda.sunmi.rest.model.LongId
import com.webssa.pda.sunmi.rest.model.ShiftState
import com.webssa.pda.sunmi.util.DateNoTime
import com.webssa.pda.sunmi.util.DurationHMS
import com.webssa.pda.sunmi.util.TimeOfDayHMS

import java.util.Date

@JsonClass(generateAdapter = true)
data class ShiftRestEntity (
        @Json(name = "shift_id")
        val id: LongId<ShiftRestEntity>,

        @Json(name = "driver_id")
        val driverId: String,

        @Json(name = "execution_date")
        val executionDate: DateNoTime,

        @Json(name = "scheduled_time_start")
        val scheduledTimeStart: TimeOfDayHMS? = null,

        @Json(name = "scheduled_duration")
        val scheduledDuration: DurationHMS? = null,

        @Json(name = "num_visits")
        val nVisits: Int = 0,

        @Json(name = "num_visits_completed")
        val nCompletedVisits: Int = 0,

        @Json(name = "num_visits_failed")
        val nFailedVisits: Int = 0,

        @Json(name = "actual_time_start")
        val actualTimeStart: Date? = null,

        @Json(name = "actual_time_closed")
        val actualTimeClosed: Date? = null,

        @Json(name = "state")
        val state: ShiftState
) : IdProvidingModel {

    override fun id(): LongId<ShiftRestEntity> {
        return id
    }
}