package com.webssa.pda.sunmi.rest.model.impl

import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass
import com.webssa.pda.sunmi.rest.model.IdProvidingModel
import com.webssa.pda.sunmi.rest.model.LongId
import com.webssa.pda.sunmi.rest.model.VisitState
import com.webssa.pda.sunmi.util.TimeOfDayHMS
import java.util.*

@JsonClass(generateAdapter = true)
data class VisitEntity(
        @Json(name = "visit_id")
        val id: LongId<VisitEntity>,            ////////////////////////////////////////////////////

        @Json(name = "shift_id")
        val shiftId: LongId<ShiftRestEntity>,   ////////////////////////////////////////////////////

        @Json(name = "site_id")
        val siteId: LongId<SiteEntity>,         ////////////////////////////////////////////////////

        @Json(name = "order")
        val order: Int,                         ////////////////////////////////////////////////////

        @Json(name = "suggest_time")
        val suggestedTime: TimeOfDayHMS? = null,////////////////////////////////////////////////////

        @Json(name = "start_time")
        val actualStartTime: Date? = null,      ////////////////////////////////////////////////////

        @Json(name = "complete_time")
        val actualCompleteTime: Date? = null,   ////////////////////////////////////////////////////

        @Json(name = "state")
        val state: VisitState,                  ////////////////////////////////////////////////////

        @Json(name = "customer_name")
        val customerName: String? = null,       ////////////////////////////////////////////////////

        @Json(name = "customer_signature")
        val customerSignature: String? = null,  ////////////////////////////////////////////////////

        @Json(name = "total_payed_amount")
        val totalPayedAmount: Int? = 0,         ////////////////////////////////////////////////////

        @Json(name = "total_payed_scale")
        val totalPayedScale: Int? = 0,          ////////////////////////////////////////////////////

        @Json(name = "white_sacks")
        val white_sacks: Boolean? = false,

        @Json(name = "clear_bags")
        val clear_bags: Int? = 0,

        @Json(name = "is_ad_hoc")
        val isAdHocVisit: Boolean? = false,

        @Json(name = "is_local_created")
        val isLocalCreated: Boolean? = false
) : IdProvidingModel {

        override fun id(): LongId<VisitEntity> {
                return id
        }

        fun copyWithAdHocFlag() : VisitEntity = VisitEntity(id = id,
                shiftId = shiftId,
                siteId = siteId,
                order = order,
                suggestedTime = suggestedTime,
                actualStartTime = actualStartTime,
                actualCompleteTime = actualCompleteTime,
                state = state,
                customerName = customerName,
                customerSignature = customerSignature,
                totalPayedAmount = totalPayedAmount,
                totalPayedScale = totalPayedScale,
                white_sacks = white_sacks,
                clear_bags = clear_bags,
                isAdHocVisit = true,
                isLocalCreated = isLocalCreated)

}