package com.webssa.pda.sunmi.service;

import android.app.IntentService;
import android.content.Context;
import android.content.Intent;
import android.util.Log;

import androidx.annotation.Nullable;

import com.webssa.Loader;
import com.webssa.pda.sunmi.PDA_Application;
import com.webssa.pda.sunmi.GlobalProperties;
import com.webssa.pda.sunmi.core.SessionHolder;

public class UploadShiftNotesService extends IntentService {
    public static final boolean D = GlobalProperties.D;
    public static final String LOG_TAG = "UPLOAD_NOTES_SERVICE";

    public static void launch(Context ctx) {
        Intent launcher = new Intent(ctx, UploadShiftNotesService.class);
        ctx.startService(launcher);
    }


    public UploadShiftNotesService() {
        super(UploadShiftNotesService.class.getSimpleName());
    }


    @Override
    protected void onHandleIntent(@Nullable Intent intent) {
        if (D) Log.i(LOG_TAG, "---> Sync Notes service has been started.");
        boolean isLoggedIn = SessionHolder.isLoggedIn();
        boolean isConnected = PDA_Application.getNetworkConnectionObserver().isConnected();
        if (!isLoggedIn || !isConnected) {
            if (D) Log.e(LOG_TAG, "<~~~ Cancel syncing notes because of not logged in or no Internet connection");
        } else {
            try {
                Thread.sleep(3000);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            Loader.loadLocalNotes();
            if (D) Log.i(LOG_TAG, "<--- Sync Notes service has been finished.");
        }
    }


}
