package com.webssa.pda.sunmi.storage.dbmodel;

import android.os.Parcelable;

import com.webssa.pda.sunmi.rest.model.IdProvidingModel;

import java.util.Calendar;
import java.util.Date;

/**
 * Created by stanislav.perchenko on 11/6/2019, 9:33 AM.
 */
public abstract class BaseNoteDbModel implements IdProvidingModel, ScheduledModel, Parcelable {

    public abstract Date createdAt();

    public abstract boolean isRemoteNote();

    @Override
    public Date scheduledDate() {
        return createdAt();
    }

    private Integer timeMillis;

    @Override
    public int scheduledTimeMillis() {
        if (timeMillis == null) {
            synchronized (this) {
                if (timeMillis == null) {
                    Calendar cal = Calendar.getInstance();
                    cal.setTime(createdAt());
                    timeMillis = (3600*cal.get(Calendar.HOUR_OF_DAY) + 60*cal.get(Calendar.MINUTE) + cal.get(Calendar.SECOND)) * 1000 + cal.get(Calendar.MILLISECOND);
                }
            }
        }
        return timeMillis.intValue();
    }

}
