package com.webssa.pda.sunmi.storage.dbmodel.impl;

import androidx.annotation.Nullable;

import com.google.auto.value.AutoValue;
import com.webssa.library.attachment.model.CoverImportModel;
import com.webssa.pda.sunmi.rest.model.LongId;
import com.webssa.pda.sunmi.rest.model.impl.EmergencyCategoryEntity;
import com.webssa.pda.sunmi.rest.model.impl.ShiftRestEntity;
import com.webssa.pda.sunmi.rest.model.impl.VisitEntity;
import com.webssa.pda.sunmi.storage.dbmodel.BaseNoteDbModel;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * Created by stanislav.perchenko on 11/5/2019, 7:58 PM.
 */
@AutoValue
public abstract class LocalNoteDbModel extends BaseNoteDbModel {
    @Nullable
    public abstract LongId<LocalNoteDbModel> id();

    public abstract LongId<ShiftRestEntity> shiftId();

    @Nullable
    public abstract LongId<VisitEntity> optVisitId();

    public abstract Date createdAt();

    public abstract String noteText();

    @Nullable
    public abstract LongId<EmergencyCategoryEntity> optEmergencyId();

    public abstract List<CoverImportModel> attachedImages();

    @Override
    public boolean isRemoteNote() {
        return false;
    }

    abstract Builder toBuilder();

    public LocalNoteDbModel withId(LongId<LocalNoteDbModel> id) {
        return toBuilder().setId(id).build();
    }

    public static Builder builder() {
        return new AutoValue_LocalNoteDbModel.Builder();
    }

    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setId(@Nullable LongId<LocalNoteDbModel> id);
        public abstract Builder setShiftId(LongId<ShiftRestEntity> shiftId);
        public abstract Builder setOptVisitId(@Nullable LongId<VisitEntity> optVisitId);
        public abstract Builder setCreatedAt(Date createdAt);
        public abstract Builder setNoteText(String noteText);
        public abstract Builder setOptEmergencyId(LongId<EmergencyCategoryEntity> optEmergencyId);
        public abstract Builder setAttachedImages(List<CoverImportModel> attachedImages);

        public abstract LocalNoteDbModel build();
    }



}
