package com.webssa.pda.sunmi.storage.dbmodel.impl;

import androidx.annotation.Nullable;

import com.google.auto.value.AutoValue;
import com.webssa.pda.sunmi.rest.model.LongId;
import com.webssa.pda.sunmi.rest.model.impl.EmergencyCategoryEntity;
import com.webssa.pda.sunmi.rest.model.impl.NoteEntity;
import com.webssa.pda.sunmi.rest.model.impl.ShiftRestEntity;
import com.webssa.pda.sunmi.rest.model.impl.VisitEntity;
import com.webssa.pda.sunmi.storage.dbmodel.BaseNoteDbModel;

import java.util.Date;
import java.util.List;

/**
 * Created by stanislav.perchenko on 10/23/2019.
 */
@AutoValue
public abstract class NoteDbModel extends BaseNoteDbModel {
    //TODO Implement this model and related DAO. Add this to ShiftDbModel and VisitDbModel !!!!!!!!!

    public abstract LongId<NoteEntity> id();

    public abstract LongId<ShiftRestEntity> shiftId();

    @Nullable
    public abstract LongId<VisitEntity> optVisitId();

    public abstract int sequenceNumber();

    public abstract String authorId();

    public abstract Date createdAt();

    public abstract String noteText();

    @Nullable
    public abstract LongId<EmergencyCategoryEntity> optEmergencyId();

    public abstract List<String> attachedImages();

    @Override
    public boolean isRemoteNote() {
        return true;
    }

    public static Builder builder() {
        return new AutoValue_NoteDbModel.Builder();
    }

    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setId(@Nullable LongId<NoteEntity> id);
        public abstract Builder setShiftId(LongId<ShiftRestEntity> shiftId);
        public abstract Builder setOptVisitId(@Nullable LongId<VisitEntity> optVisitId);
        public abstract Builder setSequenceNumber(int sequenceNumber);
        public abstract Builder setAuthorId(String authorId);
        public abstract Builder setCreatedAt(Date createdAt);
        public abstract Builder setNoteText(String noteText);
        public abstract Builder setOptEmergencyId(LongId<EmergencyCategoryEntity> optEmergencyId);
        public abstract Builder setAttachedImages(List<String> attachedImages);

        public abstract NoteDbModel build();
    }

}
