package com.webssa.pda.sunmi.storage.dbmodel.impl;

import android.os.Parcelable;

import com.google.auto.value.AutoValue;
import com.webssa.pda.sunmi.rest.model.IdProvidingModel;
import com.webssa.pda.sunmi.rest.model.LongId;
import com.webssa.pda.sunmi.rest.model.impl.EWCCodeEntity;
import com.webssa.pda.sunmi.rest.model.impl.PriceEntity;
import com.webssa.pda.sunmi.rest.model.impl.PricedGoodEntity;
import com.webssa.pda.sunmi.rest.model.impl.SiteEntity;

import java.util.Date;

import androidx.annotation.Nullable;

@AutoValue
public abstract class PricedGoodDbModel implements IdProvidingModel, Parcelable {

    public abstract LongId<PricedGoodEntity> id();

    public abstract String categoryName();

    public abstract int categoryOrder();

    public abstract LongId<PriceEntity> priceId();

    public abstract int priceValue();

    public abstract int priceScale();

    public abstract Date priceSetDate();

    @Nullable
    public abstract EWCCodeEntity ewcCode();

    @Nullable
    public abstract String unitOfMeasure();

    public abstract LongId<SiteEntity> siteId();

    public boolean isHasPrice() {
        return priceValue() > 0 && priceScale() > 0;
    }

    public static Builder builder() {
        return new AutoValue_PricedGoodDbModel.Builder();
    }

    @AutoValue.Builder
    public abstract static class Builder {
        public abstract Builder setId(LongId<PricedGoodEntity> id);
        public abstract Builder setCategoryName(String categoryName);
        public abstract Builder setCategoryOrder(int categoryOrder);
        public abstract Builder setPriceId(LongId<PriceEntity> priceId);
        public abstract Builder setPriceValue(int priceValue);
        public abstract Builder setPriceScale(int priceScale);
        public abstract Builder setPriceSetDate(Date priceSetDate);
        public abstract Builder setEwcCode(@Nullable EWCCodeEntity ewcCode);
        public abstract Builder setUnitOfMeasure(@Nullable String unitOfMeasure);
        public abstract Builder setSiteId(LongId<SiteEntity> siteId);

        public abstract PricedGoodDbModel build();
    }
}
