package com.webssa.pda.sunmi.ui;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.provider.Settings;

import com.webssa.pda.sunmi.ui.activity.ShiftActivity;

public final class NavigationHelper {

    private NavigationHelper() {
        throw new IllegalStateException("No instances");
    }

    public static void goMainScreen(Context ctx, boolean isStartFromLogin) {
        ctx.startActivity(new Intent(ctx, ShiftActivity.class).putExtra(ShiftActivity.ARG_START_FROM_LOGIN, isStartFromLogin));
    }

    public static void openApplicationSettings(Activity act) {
        Intent i = new Intent(Settings.ACTION_APPLICATION_DETAILS_SETTINGS)
                .addCategory(Intent.CATEGORY_DEFAULT)
                .setData(Uri.parse("package:" + act.getPackageName()))
                .addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_NO_HISTORY | Intent.FLAG_ACTIVITY_EXCLUDE_FROM_RECENTS);
        act.startActivity(i);
    }
}
