package com.webssa.pda.sunmi.ui.activity;

import android.Manifest;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.view.MenuItem;
import android.widget.Switch;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.core.app.ActivityCompat;

import com.google.android.material.snackbar.Snackbar;
import com.webssa.pda.sunmi.R;
import com.webssa.pda.sunmi.core.Settings;
import com.webssa.pda.sunmi.core.SettingsHolder;
import com.webssa.pda.sunmi.ui.annotation.Layout;
import com.webssa.pda.sunmi.util.Toaster;


/**
 * Created by stanislav.perchenko on 11/11/2019, 11:44 AM.
 */
@Layout(R.layout.activity_settings)
public class SettingsActivity extends BaseToolbarActivity {

    private Switch swFailNet;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        swFailNet = findViewById(R.id.sw_fail_networking);

        swFailNet.setChecked(SettingsHolder.getInstance().getSettings().useFailNetworking());

        swFailNet.setOnCheckedChangeListener((buttonView, isChecked) -> {
            Settings s = SettingsHolder.getInstance().getSettings();
            SettingsHolder.getInstance().setSettings(s.withUseFailNetworking(isChecked));
        });
    }

    @Nullable
    @Override
    protected Integer getToolbarResId() {
        return R.id.toolbar;
    }

    @Nullable
    @Override
    protected String getScreenTitle() {
        return getString(R.string.screen_title_settings);
    }

    @Nullable
    @Override
    protected String getScreenSubTitle() {
        return null;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        if (item.getItemId() == android.R.id.home) {
            onBackPressed();
            return true;
        } else {
            return super.onOptionsItemSelected(item);
        }
    }

    @Override
    public void onBackPressed() {
        if (locationPermissionSnack != null) {
            locationPermissionSnack.dismiss();
            locationPermissionSnack = null;
        } else {
            super.onBackPressed();
        }
    }


    private Snackbar locationPermissionSnack;
}
