package com.webssa.pda.sunmi.ui.activity;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.webssa.library.core.error.AppError;
import com.webssa.pda.sunmi.rest.model.LongId;
import com.webssa.pda.sunmi.rest.model.impl.ShiftRestEntity;
import com.webssa.pda.sunmi.storage.dbmodel.impl.ShiftDbModel;
import com.webssa.pda.sunmi.storage.dbmodel.impl.VisitDbModel;
import com.webssa.pda.sunmi.ui.baseview.ContextProvidingView;

import java.util.Date;

/**
 * Created by stanislav.perchenko on 10/18/2019.
 */
public interface ShiftActivityView extends ContextProvidingView {

    void onShiftFound(@NonNull ShiftDbModel savedShift);
    void onNewShiftFound(@NonNull ShiftRestEntity shift, @NonNull Date serverTime);


    void onNewShiftNotFound(@Nullable AppError reason);


    void onNewShiftAcceptFailed(@NonNull AppError reason);

    void onNewShiftRejected(@NonNull LongId<ShiftRestEntity> shiftId);
    void onNewShiftRejectFailed(@NonNull AppError reason);

    void onShiftUpdateFailed(@NonNull LongId<ShiftRestEntity> shiftId, @NonNull AppError reason);

    void onAllSitesLoaded(int nSites);
    void onLoadAllSitesError(AppError reason);


    /********************************  Start Visit  ***********************************************/
    void onStartVisitStartApi();
    void onEndVisitStartApi();

    void onVisitStarted(VisitDbModel visit);
    void onStartVisitFailed(AppError reason);

    /********************************  Sync Visits  ***********************************************/
    void onSyncVisitsStarted();
    void onSyncVisitsFinished(int nChanged);

    /********************************  Ad-Hoc visit  **********************************************/
    void onAdHocVisitCreated(VisitDbModel adHocVisit);
    void onAdHocVisitNotCreated(AppError resason);
}
