package com.webssa.pda.sunmi.ui.widget;


import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Rect;
import android.util.AttributeSet;

import com.webssa.pda.sunmi.R;

import me.dm7.barcodescanner.core.IViewFinder;
import me.dm7.barcodescanner.core.ViewFinderView;
import me.dm7.barcodescanner.zxing.ZXingScannerView;

/**
 * Created by stanislav.perchenko on 11/6/2019, 6:37 PM.
 */
public class ZXingScannerCustomView extends ZXingScannerView {

    private int viewFinderMargin = -1;

    public ZXingScannerCustomView(Context context) {
        super(context);
    }

    public ZXingScannerCustomView(Context context, AttributeSet attrs) {
        super(context, attrs);
        TypedArray a = context.getResources().obtainAttributes(attrs, R.styleable.ZXingScannerCustomView);
        try {
            viewFinderMargin = a.getDimensionPixelSize(R.styleable.ZXingScannerCustomView_viewFinderPadding, -1);
        } finally {
            a.recycle();
        }
    }


    @Override
    protected IViewFinder createViewFinderView(Context context) {
        return new ViewFinderView(context) {
            private Rect framingRect;

            @Override
            public synchronized void updateFramingRect() {
                if (viewFinderMargin >= 0) {
                    int w = getWidth();
                    int h = getHeight();
                    int width = ((w < h) ? w : h) - viewFinderMargin * 2;
                    int left = (w - width) / 2;
                    int top = (h - width) / 2;
                    framingRect = new Rect(left, top, left + width, top + width);
                } else {
                    super.updateFramingRect();
                    framingRect = null;
                }
            }

            @Override
            public Rect getFramingRect() {
                return (framingRect == null) ? super.getFramingRect() : framingRect;
            }
        };
    }
}
