package com.webssa.pda.sunmi.util;

import android.content.Context;
import android.text.TextUtils;
import android.view.View;
import android.widget.Toast;

import androidx.annotation.NonNull;

import com.google.android.material.snackbar.Snackbar;
import com.webssa.library.core.error.AppError;
import com.webssa.pda.sunmi.PDA_Application;
import com.webssa.pda.sunmi.GlobalProperties;

/**
 * Created by stanislav.perchenko on 10/22/2019.
 */
public final class Toaster {

    public static void toastError(Context c, @NonNull AppError err, int textResId) {
        String msg = (GlobalProperties.D && !TextUtils.isEmpty(err.getInternalMessage()))
                ? String.format("%s - %s (%s)", c.getString(textResId), err.getUserMessage(), err.getInternalMessage())
                : String.format("%s - %s", c.getString(textResId), err.getUserMessage());
        Toast.makeText(c, msg, Toast.LENGTH_LONG).show();
    }

    public static void toastError(Context c, @NonNull AppError err, String text) {
        String msg = (GlobalProperties.D && !TextUtils.isEmpty(err.getInternalMessage()))
                ? String.format("%s - %s (%s)", text, err.getUserMessage(), err.getInternalMessage())
                : String.format("%s - %s", text, err.getUserMessage());
        Toast.makeText(c, msg, Toast.LENGTH_LONG).show();
    }

    public static void toastError(Context c, @NonNull AppError err) {
        String msg = (GlobalProperties.D && !TextUtils.isEmpty(err.getInternalMessage()))
                ? String.format("%s - %s", err.getUserMessage(), err.getInternalMessage())
                : err.getUserMessage();
        Toast.makeText(c, msg, Toast.LENGTH_LONG).show();
    }


    public static Toast toastToUser(int resId, int length) {
        Toast t = Toast.makeText(PDA_Application.getStaticAppContext(), resId, length);
        t.show();
        return t;
    }

    public static Toast toastToUser(CharSequence text, int length) {
        Toast t = Toast.makeText(PDA_Application.getStaticAppContext(), text, length);
        t.show();
        return t;
    }

    public static void showSnackbar(View container, final String text) {
        if (container != null) {
            Snackbar.make(container, text, Snackbar.LENGTH_LONG).show();
        }
    }

    public static Snackbar showSnackbar(View container, final int mainTextStringId, final int actionStringId, View.OnClickListener listener) {
        Context ctx = container.getContext();
        Snackbar sb = Snackbar.make(container, ctx.getString(mainTextStringId), Snackbar.LENGTH_INDEFINITE)
                .setAction(ctx.getString(actionStringId), listener);
        sb.show();
        return sb;
    }

    private Toaster() { }


}
