package com.alperez.sunmi.pos.receiptengine.template;

import androidx.annotation.Nullable;

import java.text.NumberFormat;
import java.util.Locale;

/**
 * Created by stanislav.perchenko on 11/15/2019, 10:32 AM.
 */
public final class PublicUtils {


    private PublicUtils() {
        throw new IllegalStateException("No instances allowed");
    }

    public static String formatPrice(long amount, int scale, @Nullable String prefix, @Nullable String suffix) {

        double value = amount;
        for (int i = 0; i < scale; i++) value /= 10;


        if ((prefix != null) && (suffix != null)) {
            return String.format("%s%." + scale + "f%s", prefix, value, suffix);
        } else if (prefix != null) {
            return String.format("%s%." + scale + "f", prefix, value);
        } else if (suffix != null) {
            return String.format("%." + scale + "f%s", value, suffix);
        } else {
            return String.format("%." + scale + "f", value);
        }
    }

    public static String formatPriceAsCurrency(long amount, int scale, Locale locale) {
        double value = amount;
        for (int i = 0; i < scale; i++) value /= 10;

        return NumberFormat.getCurrencyInstance(locale).format(value);
    }

    public static double buildPriceValue(long amount, int scale) {
        double value = amount;
        for (int i = 0; i < scale; i++) value /= 10;
        return value;
    }
}
