package com.webssa.library.attachment.model;

import android.os.Parcelable;

import com.google.auto.value.AutoValue;

import java.util.Date;

/**
 * Created by stanislav.perchenko on 11/8/2016.
 */
@AutoValue
public abstract class AttachmentImportModel implements Parcelable {
    public abstract String localFilePath();
    public abstract String mimeType();
    public abstract int durationMillis();
    public abstract String relativeHashName();
    public abstract AttachmentType attachmentType();
    public abstract Date createdAt();

    public static AttachmentImportModel create(String localFile, String mimeType, int durationMillis, String relativeHashName, AttachmentType attachmentType, Date createdAt) {
        return new AutoValue_AttachmentImportModel(localFile, mimeType, durationMillis, relativeHashName, attachmentType, createdAt);
    }

}
