﻿using PDA.Database.EntityModels;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace PDA.BL.Interfaces
{
    public interface IVisitService
    {
        Task<Visit> StartVisit(int visitId, DateTimeOffset? delayedStartTime, string userId);
        Task<Visit> FailVisit(int visitId, DateTimeOffset? delayedFailTime, string noteText, List<string> imageUrls, int emergencyId,  string userId);
        Task<Visit> CompleteVisit(int visitId, DateTimeOffset? delayedCompleteTime, Note note, string userId, List<string> imageUrls, List<CollectedGood> goods,
            string customerName, string customerSig, int clearBags, bool isWhiteSacks);
        Task<Visit> GetVisitById(int id);
        Task<Visit> GetVisitState(int visitId, string userId);
        Task<Visit> AddVisit(int shiftId, int siteId, DateTime? suggestTime, string userId);
    }
}
