﻿using PDA.BL.Interfaces;
using PDA.Database.EntityModels;
using PDA.Database.Interfaces;
using PDA.Database.Models;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;

namespace PDA.BL.Services
{
    public class ShiftService : IShiftService
    {
        private readonly IShiftRepository _shiftRepository;
        public ShiftService(IShiftRepository shiftRepository) => _shiftRepository = shiftRepository;

        public async Task<Shift> AcceptShift(int shiftId) => await _shiftRepository.AcceptShift(shiftId);

        public async Task<Shift> CloseShift(int shiftId, DateTime closeTime, string userId) => await _shiftRepository.CloseShift(shiftId, closeTime, userId);
     
        public async Task<Shift> FindNewShiftForDate(string userId) => await _shiftRepository.FindNewShiftForDate(userId);

        public async Task<Shift> GetByShiftId(int shiftId, string userId) => await _shiftRepository.GetByShiftId(shiftId, userId);
       
        public async Task<Shift> RejectShift(int shiftId, string userId) => await _shiftRepository.RejectShift(shiftId, userId);
      
    }
}
