﻿using PDA.BL.Interfaces;
using PDA.Database.EntityModels;
using PDA.Database.Interfaces;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;
namespace PDA.BL.Services
{
    public class VisitService : IVisitService
    {
        private readonly IVisitRepository _visitRepository;
        public VisitService(IVisitRepository visitRepository) => _visitRepository = visitRepository;
        public async Task<Visit> StartVisit(int visitId, DateTimeOffset? delayedStartTime, string userId) => await _visitRepository.StartVisit(visitId, delayedStartTime, userId);
        public async Task<Visit> FailVisit(int visitId, DateTimeOffset? delayedFailTime, string noteText, List<string> imageUrls, int emergencyId, string userId) => 
            await _visitRepository.FailVisit(visitId, delayedFailTime, noteText, imageUrls, emergencyId, userId);
        public async Task<Visit> CompleteVisit(int visitId, DateTimeOffset? delayedCompleteTime, Note note, string userId, List<string> imageUrls, List<CollectedGood> goods,
            string customerName, string customerSig, int clearBags, bool isWhiteSacks) => await _visitRepository.CompleteVisit(visitId, delayedCompleteTime, note, userId, imageUrls, goods, customerName, customerSig, clearBags, isWhiteSacks);
        
        
        public async Task<Visit> GetVisitById(int id) => await _visitRepository.GetVisitById(id);
        public async Task<Visit> GetVisitState(int visitId, string userId) => await _visitRepository.GetVisitState(visitId, userId);
        public async Task<Visit> AddVisit(int shiftId, int siteId, DateTime? suggestTime, string userId) => await _visitRepository.AddVisit(shiftId, siteId, suggestTime, userId);
    }
}
