﻿using Microsoft.AspNetCore.Identity;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Text;

namespace PDA.Database.EntityModels
{
    public class User: IdentityUser
    {
        public bool Deleted { get; set; }
        [Column(TypeName = "varchar(256)")]
        public string PhotoURL { get; set; }
        [Column(TypeName = "varchar(64)")]
        public string PinHash { get; set; }
        [Column(TypeName = "varchar(256)")]
        public string FirstName { get; set; }
        [Column(TypeName = "varchar(256)")]
        public string LastName { get; set; }
        public DateTime RegistrationDate { get; set; }
        public  List<Shift> Shifts { get; set; }
        public  List<Note> Notes { get; set; }
        public  List<UserToken> Tokens { get; set; }
    }
}
