﻿using Newtonsoft.Json.Linq;
using PDA.Database.Interfaces;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;

namespace PDA.Database.Models
{
    public class SecurityConfiguration : ISecurityConfiguration
    {
        private static readonly string PathToSettings = AppContext.BaseDirectory
            + @"settings.json";
        public string RijndaelPassPhrase { get; set; }
        public string RijndaelSalt { get; set; }
        public string RijndaelAlgorithm { get; set; }
        public string RijndaelInitVector { get; set; }
        public int RijndaelKeySize { get; set; }
        public int RijndaelPasswordIteration { get; set; }

        public static SecurityConfiguration Read()
        {
            return JObject.Parse(File.ReadAllText(PathToSettings))["SecurityConfig"].ToObject<SecurityConfiguration>();
        }
    }
}
