﻿using Microsoft.EntityFrameworkCore;
using PDA.Database.EntityModels;
using PDA.Database.Interfaces;
using PDA.Database.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PDA.Database.Repositories
{
    public class DriverRepository : IDriverRepository
    {
        private readonly PDADbContext _context;
        public DriverRepository(PDADbContext context)
        {
            _context = context;
        }
        public async Task<string> CheckDriverExists(string phone, string pin)
        {
           var driver =  await _context.Users.FirstOrDefaultAsync(x => !x.Deleted && x.PhoneNumber == phone && x.PinHash == pin);
            return driver != null ? driver.Id : null;
        }

        public async Task<string> CheckDriverExistsEmail(string email, string pin)
        {
            var driver = await _context.Users.FirstOrDefaultAsync(x => !x.Deleted && x.Email == email && x.PinHash == pin);
            return driver != null ? driver.Id : null;
        }

        public async Task<User> GetDriverByIdAsync(string id) => await _context.Users.FirstOrDefaultAsync(x => x.Id == id);
      

        public string GetUserRole(string id)
        {
            var roleId = _context.UserRoles.FirstOrDefault(x => x.UserId == id).RoleId;
            return _context.Roles.FirstOrDefault(x => x.Id == roleId).Name;         
        }
    }
}
