﻿using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using PDA.API.Filters;
using PDA.API.WebModels;
using PDA.BL.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace PDA.API.Controllers.v1
{
    [ServiceFilter(typeof(AuthorizationTokenAttribute))]
    public class EmergencyController: ControllerBase
    {
        private readonly IEmergencyService _emergencyService;
        private readonly IMapper _mapper;
        private string CurrentUserId => Request.Headers["User"];
        public EmergencyController(IEmergencyService emergencyService, IMapper mapper)
        {
            _emergencyService = emergencyService;
            _mapper = mapper;
        }
        [HttpGet("emergencies")]
        public async Task<List<EmergencyEntity>> GetEmergenciesList()
        {
            var emergencies = await _emergencyService.GetEmergencies();
            var mappedEmergencies = new List<EmergencyEntity>();
            foreach (var emergency in emergencies)
                mappedEmergencies.Add(_mapper.Map<EmergencyEntity>(emergency));
            return mappedEmergencies;
        }
    }
}
