﻿using AutoMapper;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using PDA.API.Filters;
using PDA.BL.Interfaces;
using PDA.Database.CustomExceptions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace PDA.API.Controllers.v1
{
    [ServiceFilter(typeof(AuthorizationTokenAttribute))]
    public class ImagesController : Controller
    {
        private readonly IUploadFileService _uploadFileService;
        public ImagesController(IUploadFileService uploadFileService) => _uploadFileService = uploadFileService;

        [HttpPost("images/upload")]
        public async Task<List<string>> UploadImages(IList<IFormFile> images)
        {
            if (images == null || images.Count == 0)
                throw new ImagesNotProvidedException();
            return await _uploadFileService.UploadImages(images);
        }
    }
}
