﻿using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using PDA.API.Filters;
using PDA.API.WebModels;
using PDA.BL.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using PDA.Database.Repositories;
using PDA.Database.Interfaces;
using PDA.Database.EntityModels;

namespace PDA.API.Controllers.v1
{
    [ServiceFilter(typeof(AuthorizationTokenAttribute))]
    public class SitesController : ControllerBase
    {
        private readonly ISiteRepository _siteRepo;
        private readonly IMapper _mapper;
        public SitesController(ISiteRepository siteRepo, IMapper mapper)
        {
            _siteRepo = siteRepo;
            _mapper = mapper;
        }
        [HttpGet("sites")]
        public async Task<IEnumerable<SiteEntity>> GetAll()
        {
            var sites = await _siteRepo.GetAllActive();
            return _mapper.Map<IEnumerable<SiteEntity>>(sites);
        }
    }
}
