﻿using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using PDA.API.Filters;
using PDA.API.WebModels;
using PDA.BL.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace PDA.API.Controllers.v1
{
    [ServiceFilter(typeof(AuthorizationTokenAttribute))]
    public class UserController: ControllerBase
    {
        private readonly IDriverService _driverService;
        private readonly IMapper _mapper;
        private string CurrentUserId => Request.Headers["User"];
        public UserController(IDriverService driverService, IMapper mapper)
        {
            _driverService = driverService;
            _mapper = mapper;
        }
        [HttpGet("users/me")]
        public async Task<UserEntity> GetUser()
        {
            var user = await _driverService.GetDriverAsync(CurrentUserId);
            var userEntity = _mapper.Map<UserEntity>(user);
            userEntity.Role =  _driverService.GetUserRole(CurrentUserId);
            return userEntity;
        }
    }
}
