﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace PDA.API.CustomExtensions
{
    public static class CustomExtensions
    {
        public static string ToISOString(this DateTimeOffset dateTimeOffset)
        {
            return $"{dateTimeOffset.Year}-{dateTimeOffset.Month}-{dateTimeOffset.Day}T{dateTimeOffset.Hour}:{dateTimeOffset.Minute}:{dateTimeOffset.Second}." +
                $"{dateTimeOffset.Millisecond.CutMiliseconds()}{dateTimeOffset.Offset.TimeSpanToFormat()}"; 
        }
        public static int CutMiliseconds(this int miliseconds)
        {
            if (miliseconds < 1000)
                return miliseconds;
            return CutMiliseconds((miliseconds - (miliseconds % 10)) / 10);
        }
        public static string TimeSpanToFormat(this TimeSpan timeSpan)
        {
            var hours = timeSpan.Hours < 10 ? $"0{timeSpan.Hours}" : $"{timeSpan.Hours}";
            var minutes = timeSpan.Minutes < 10 ? $"0{timeSpan.Minutes}" : $"{timeSpan.Minutes}";
            var symbol = timeSpan.Ticks >= 0 ? "+" : "-";
            return symbol + hours + minutes;
        }
    }
    
}
