﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Filters;
using PDA.API.Errors;
using PDA.Database.CustomExceptions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace PDA.API.Filters
{
    public class LoginExceptionFilterAttribute: ExceptionFilterAttribute
    {
        public override Task OnExceptionAsync(ExceptionContext context)
        {
            IActionResult result;
            switch (context.Exception)
            {
                case InvalidParamsException ve:
                    result = new BadRequestObjectResult(ve.Message) { StatusCode = (int)ApiErrorCode.BadRequest };
                    break;
            
                default:
                    return base.OnExceptionAsync(context);
            }
            context.Result = result;
            return Task.CompletedTask;
        }
    }
}
